package com.sun.s1asdev.jdbc.statementtimeout.client;

import javax.naming.*;

import com.sun.s1asdev.jdbc.statementtimeout.ejb.SimpleBMPHome;
import com.sun.s1asdev.jdbc.statementtimeout.ejb.SimpleBMP;
import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

import javax.sql.DataSource;
import java.sql.*;
import javax.transaction.*;

public class SimpleBMPClient {

    public static void main(String[] args)
            throws Exception {

        SimpleReporterAdapter stat = new SimpleReporterAdapter();
        String testSuite = "StatementTimeout ";

        InitialContext ic = new InitialContext();
        Object objRef = ic.lookup("java:comp/env/ejb/SimpleBMPHome");
        SimpleBMPHome simpleBMPHome = (SimpleBMPHome)
                javax.rmi.PortableRemoteObject.narrow(objRef, SimpleBMPHome.class);

        SimpleBMP simpleBMP = simpleBMPHome.create();
	stat.addDescription("JDBC Statement Timeout Tests");

        try{
            InitialContext ict = new InitialContext();

            UserTransaction ut = (UserTransaction) ict.lookup(
                "java:comp/UserTransaction");

            ut.begin();
            DataSource ds = (DataSource)ict.lookup("java:app/jdbc/s1qeDB");
            System.out.println("Got datasource : " + ds);
                Connection c = ds.getConnection();
                Statement stmt = c.createStatement();
                stmt.executeQuery("select * from sys.systables");
                stmt.close();
                c.close();

            ut.commit();

            stat.addStatus(testSuite + " appclient txn test : ", SimpleReporterAdapter.PASS);
        }catch(Throwable t){
		t.printStackTrace();
            stat.addStatus(testSuite + " appclient txn test : ", SimpleReporterAdapter.FAIL);
        }
        stat.printSummary();
    }
}
